From 531ad74ad2dc556160f694ee2f3922efc87bd5d9 Mon Sep 17 00:00:00 2001
From: Aaron Meurer <asmeurer@gmail.com>
Date: Sat, 27 Feb 2010 00:25:44 -0700
Subject: [PATCH 1/1] Basic demonstrative fixes for StrictInequality

This is NOT intended for review.

Problems so far:
- I'm sure the object oriented stuff is wrong.  Someone with more
knowledge should fix it up.
- Only StrictInequality is done for now.
- There has to be a better way to compare real numbers than lhs.evalf()
<= rhs.evalf().  Does mpmath have some kind of comparison function?
- I used old assumptions (.is_real) for now, because I didn't want to
bother to see if the new ones would work.

The good news:
- All tests pass.
- .subs() works.
- StrictInequality returns a bool when the args are real numbers and an
object otherwise.  If it is an object, bool(that object) will return
True always. I didn't delete the old code here, but it needs to go.
---
 sympy/core/relational.py |   11 +++++++++++
 1 files changed, 11 insertions(+), 0 deletions(-)

diff --git a/sympy/core/relational.py b/sympy/core/relational.py
index 2bb3033..1e367eb 100644
--- a/sympy/core/relational.py
+++ b/sympy/core/relational.py
@@ -172,9 +172,20 @@ class Inequality(Relational):
 
     __slots__ = []
 
+    def __new__(self, lhs, rhs):
+        lhs, rhs = (_sympify(lhs), _sympify(rhs))
+        if lhs.is_real and lhs.is_number and rhs.is_real and rhs.is_number:
+            return lhs.evalf() <= rhs.evalf()
+        else:
+            return Basic.__new__(Inequality, lhs, rhs)
+
     def __nonzero__(self):
+        return True
         if self.lhs.is_comparable and self.rhs.is_comparable:
             if self.lhs.is_Number and self.rhs.is_Number:
                 return self.lhs <= self.rhs
             return self.lhs.evalf()<=self.rhs.evalf()
         return self.lhs.compare(self.rhs)<=0
+
+    def _eval_subs(self, old, new):
+        return self.__new__(self, self.lhs._eval_subs(old, new), self.rhs._eval_subs(old, new))
-- 
1.6.6.1

